////////////////////////////////////////////////////////////////////////////////
//
// FRAGMENT SHADER
//
////////////////////////////////////////////////////////////////////////////////

/******************************************************************************
 * Publication: By-Example Point Process Texture Basis Functions
 * Authors: anonymous
 ******************************************************************************/

////////////////////////////////////////////////////////////////////////////////
// VERSION
////////////////////////////////////////////////////////////////////////////////

// OpenGL
#version 460

////////////////////////////////////////////////////////////////////////////////
// INPUT
////////////////////////////////////////////////////////////////////////////////

// Texture coordinates
in vec2 texCoord;

////////////////////////////////////////////////////////////////////////////////
// OUTPUT
////////////////////////////////////////////////////////////////////////////////

layout (location = 0) out vec4 oColor;

////////////////////////////////////////////////////////////////////////////////
// UNIFORM
////////////////////////////////////////////////////////////////////////////////

// Texture
uniform sampler2D uTexture;

uniform int uSelected;

////////////////////////////////////////////////////////////////////////////////
// PROGRAM
////////////////////////////////////////////////////////////////////////////////
void main()
{
	float pptbf = texture( uTexture, texCoord ).x;
		
	vec3 color = vec3( pptbf );
	
	// Selection
	vec3 selectionColor = vec3( 1.0 );
	if ( uSelected == 1 )
	{
		selectionColor = vec3( 1.0, 0.0, 0.0 );	
	}
	color *= selectionColor;
			
	oColor = vec4( color, 1.0 );
}
